//----------------------------------------------------------------------------------------------

// OpenClipView.m

//----------------------------------------------------------------------------------------------

/*



*/

#import "OpenClipView.h"

#import "OpenClipDefines.h"
#import "NSBezierPathAdditions.h"
#import "OpenClipUtils.h"
#import "MoreOpenClipUtils.h"

@implementation OpenClipView


@synthesize fileName = mFileName;

- (id)initWithFrame:(NSRect)frame
{
  self = [super initWithFrame:frame];
  
  if (self) {
    //NSLog(@"OpenClipView initWithFrame");
    mFileName = @"OpenClip";
  }
  return self;
}


- (void)dealloc
{
  [super dealloc];
}

/*
- (BOOL)getScale:(NSDictionary *)TheDict theScale:(double *)theScale
{
  BOOL Result = NO;
  
  NSNumber *nScale = [TheDict objectForKey:OpenClip_DrawingScale];
  
  if (nScale) {
    *theScale = [nScale doubleValue];
    Result = YES;
  };
  
  return Result;
};
*/
/*
- (BOOL)getGlobalOrigin:(NSDictionary *)TheDict theOrigin:(NSPoint *)theOrigin
{
  BOOL Result = NO;
  
  NSDictionary *PtDict = [TheDict objectForKey:OpenClip_GlobalOrigin];

  if (PtDict) {
    NSNumber *nX = [PtDict objectForKey:OpenClip_X];
    NSNumber *nY = [PtDict objectForKey:OpenClip_Y];
    
    if (nX && nY) {
      theOrigin->x = [nX doubleValue];
      theOrigin->y = [nY doubleValue];
      Result = YES;
    };
    
  };
      
  return Result;
};
*/
/*
- (BOOL)getInsertionPoint:(NSDictionary *)TheDict thePt:(NSPoint *)thePt
{
  BOOL Result = NO;
  
  NSDictionary *PtDict = [TheDict objectForKey:OpenClip_InsertionPoint];
  
  if (PtDict) {
    NSNumber *nX = [PtDict objectForKey:OpenClip_X];
    NSNumber *nY = [PtDict objectForKey:OpenClip_Y];
    
    if (nX && nY) {
      thePt->x = [nX doubleValue];
      thePt->y = [nY doubleValue];
      Result = YES;
    };
    
  };  
  
  return Result;
};
*/

/*
- (BOOL)getLayerName:(NSDictionary *)TheNSLayer theLayerName:(NSString *)theLayerName
{
  BOOL Result = NO;

  theLayerName = [TheNSLayer objectForKey:OpenClip_LayerName];
  
  if (theLayerName)
    Result = YES;
    
  return Result;
};
*/
/*
- (BOOL)getLayerColor:(NSDictionary *)TheNSLayer r:(float *)r g:(float *)g b:(float *)b a:(float *)a
{
  BOOL Result = NO;
  
  NSDictionary *TheColor = [TheNSLayer objectForKey:OpenClip_LayerColor];
  
  if (TheColor) {
    NSNumber *nR = [TheColor objectForKey:OpenClip_Red];
    NSNumber *nG = [TheColor objectForKey:OpenClip_Green];
    NSNumber *nB = [TheColor objectForKey:OpenClip_Blue];
    NSNumber *nA = [TheColor objectForKey:OpenClip_Alpha];
    
    if (nR && nG && nB && nA) {
      *r = [nR floatValue];
      *g = [nG floatValue];
      *b = [nB floatValue];
      *a = [nA floatValue];
      Result = YES;
    }
    
  };
  
  return Result;
};
*/
/*
- (BOOL)getLayerScale:(NSDictionary *)TheNSLayer theScale:(double *)theScale
{
  BOOL Result = NO;
  
  NSNumber *nTheScale = [TheNSLayer objectForKey:OpenClip_LayerScale];
  
  if (nTheScale) {
    *theScale = [nTheScale doubleValue];
    Result = YES;
  };
    
  return Result;
};
*/
/*
- (BOOL)get2DPoint:(NSArray *)Points theIndex:(int)theIndex thePt:(NSPoint *)thePt
{
  BOOL Result = NO;
  
  int LastN = [Points count] - 1;
  
  if (theIndex <= LastN) {
    NSDictionary *PtDict = [Points objectAtIndex:theIndex];
    
    if (PtDict) {
      NSNumber *nX = [PtDict objectForKey:OpenClip_X];
      NSNumber *nY = [PtDict objectForKey:OpenClip_Y];
      
      if (nX && nY) {
        thePt->x = [nX doubleValue];
        thePt->y = [nY doubleValue];
        Result = YES;
      };
      
    };
  
  };
  
  return Result;
};
*/
/*
- (BOOL)get3DPoint:(NSArray *)Points theIndex:(int)theIndex thePt:(NSPoint *)thePt Z:(double *)Z
{
  BOOL Result = NO;
  
  int LastN = [Points count] - 1;
  
  if (theIndex <= LastN) {
    NSDictionary *PtDict = [Points objectAtIndex:theIndex];
    
    if (PtDict) {
      NSNumber *nX = [PtDict objectForKey:OpenClip_X];
      NSNumber *nY = [PtDict objectForKey:OpenClip_Y];
      NSNumber *nZ = [PtDict objectForKey:OpenClip_Z];
      
      if (nX && nY && nZ) {
        thePt->x = [nX doubleValue];
        thePt->y = [nY doubleValue];
        *Z       = [nZ doubleValue];
        Result = YES;
      };
      
    };
  
  };
  
  return Result;
};
*/
/*
- (BOOL)getObjectZ:(NSDictionary *)TheObj Z:(double *)Z
{
  BOOL Result = NO;
  
  NSNumber *nZ = [TheObj objectForKey:OpenClip_Z];
  
  if (nZ) {
    *Z = [nZ doubleValue];
    Result = YES;
  };
  
  return Result;
};
*/
/*
- (BOOL)getObjectClosed:(NSDictionary *)TheObj Closed:(BOOL *)Closed
{
  BOOL Result = NO;
  
  NSNumber *nClosed = [TheObj objectForKey:OpenClip_Closed];
  
  if (nClosed) {
    *Closed = [nClosed boolValue];
    Result = YES;
  };
  
  return Result;
};
*/
/*
- (BOOL)getPenColor_:(NSDictionary *)TheObj
{
  BOOL GotColor = NO;
  
  NSDictionary *TheColor = [TheObj objectForKey:OpenClip_PenColor];
  
  if (TheColor) {
    NSNumber *nR = [TheColor objectForKey:OpenClip_Red];
    NSNumber *nG = [TheColor objectForKey:OpenClip_Green];
    NSNumber *nB = [TheColor objectForKey:OpenClip_Blue];
    NSNumber *nA = [TheColor objectForKey:OpenClip_Alpha];
    
    if (nR && nG && nB && nA) {
      float R = [nR floatValue];
      float G = [nG floatValue];
      float B = [nB floatValue];
      float A = [nA floatValue];
      
      NSColor *PenColor = [NSColor colorWithCalibratedRed:R green:G blue:B alpha:A];
      [PenColor setStroke];
      GotColor = YES;
    }
    else
      [[NSColor blackColor] setStroke];
    
  };
  
  return GotColor;
};
*/
/*
- (BOOL)getFillColor_:(NSDictionary *)TheObj
{
  BOOL GotColor = NO;
  
  NSDictionary *TheColor = [TheObj objectForKey:OpenClip_FillColor];
  
  if (TheColor) {
    NSNumber *nR = [TheColor objectForKey:OpenClip_Red];
    NSNumber *nG = [TheColor objectForKey:OpenClip_Green];
    NSNumber *nB = [TheColor objectForKey:OpenClip_Blue];
    NSNumber *nA = [TheColor objectForKey:OpenClip_Alpha];
    
    if (nR && nG && nB && nA) {
      float R = [nR floatValue];
      float G = [nG floatValue];
      float B = [nB floatValue];
      float A = [nA floatValue];
      
      NSColor *FillColor = [NSColor colorWithCalibratedRed:R green:G blue:B alpha:A];
      [FillColor setFill];
      GotColor = YES;
    }
    else
      [[NSColor blackColor] setFill];
    
  };
  
  return GotColor;
};
*/
/*
- (BOOL)getPenSize_:(NSDictionary *)TheObj TheSize:(float *)TheSize
{
  BOOL Result = NO;
  
  NSNumber *nTheSize = [TheObj objectForKey:OpenClip_PenSize];
  
  if (nTheSize) {
    *TheSize = [nTheSize floatValue];
    Result = YES;
  };
  
  return Result;
};
*/
/*
- (void)getLineDash_:(NSDictionary *)TheObj ThePath:(NSBezierPath *)ThePath
{
  NSArray *Dashes = [TheObj objectForKey:OpenClip_LineDash];
  
  if (Dashes) {
    int TheCount = [Dashes count];
    int LastN = TheCount - 1;
        
    //float Pattern[TheCount];
    CGFloat Pattern[TheCount];
    
    for (int N = 0; N <= LastN; N++) {
      NSNumber *NbrDashLength = [Dashes objectAtIndex:N];
      double DashLength = [NbrDashLength floatValue];
      Pattern[N] = DashLength;
    };
  
    [ThePath setLineDash:Pattern count:TheCount phase:0];
  };
  
};
*/
/*
- (BOOL)getRotationAngle_:(NSDictionary *)TheObj TheAngle:(double *)TheAngle
{
  BOOL Result = NO;
  
  NSNumber *nTheAngle = [TheObj objectForKey:OpenClip_RotationAngle];
  
  if (nTheAngle) {
    *TheAngle = [nTheAngle doubleValue];
    Result = YES;
  };
  
  return Result;
};
*/
/*
- (BOOL)getStartAngle_:(NSDictionary *)TheObj TheAngle:(double *)TheAngle
{
  BOOL Result = NO;
  
  NSNumber *nTheAngle = [TheObj objectForKey:OpenClip_StartAngle];
  
  if (nTheAngle) {
    *TheAngle = [nTheAngle doubleValue];
    Result = YES;
  };
  
  return Result;
};
*/

/*
- (BOOL)getArcAngle_:(NSDictionary *)TheObj TheAngle:(double *)TheAngle
{
  BOOL Result = NO;
  
  NSNumber *nTheAngle = [TheObj objectForKey:OpenClip_ArcAngle];
  
  if (nTheAngle) {
    *TheAngle = [nTheAngle doubleValue];
    Result = YES;
  };
  
  return Result;
};
*/
/*
- (BOOL)getCornerRadius_:(NSDictionary *)TheObj TheRadius:(double *)TheRadius
{
  BOOL Result = NO;
  
  NSNumber *nTheRadius = [TheObj objectForKey:OpenClip_CornerRadius];
  
  if (nTheRadius) {
    *TheRadius = [nTheRadius doubleValue];
    Result = YES;
  };
  
  return Result;
};
*/

/*
- (void)drawAPoint:(NSPoint)A      // used for debugging
{
  NSBezierPath* ThePath = [NSBezierPath bezierPath];
  [ThePath setLineCapStyle:NSRoundLineCapStyle];
  [ThePath moveToPoint:A];
  [ThePath appendBezierPathWithCrossOfSize:3.0];
  
  [[NSColor redColor] setStroke];
  
  [ThePath setLineWidth:1];
  [ThePath stroke];
};
*/

- (void)drawPoint:(NSDictionary *)TheObj
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    NSPoint A;
    //if ([self get2DPoint_:Points theIndex:0 thePt:&A]) {
    if (Get2DPointOpenClip(Points,0,&A)) {
      NSBezierPath* ThePath = [NSBezierPath bezierPath];
      [ThePath setLineCapStyle:NSRoundLineCapStyle];
      [ThePath moveToPoint:A];
      [ThePath appendBezierPathWithCrossOfSize:3.0];
      
      //if ([self getPenColor_:TheObj]) {
      if (GetPenColorAndSetStrokeOpenClip(TheObj)) {
        
      };
      
      [ThePath setLineWidth:1];
      [ThePath stroke];
    };
  
  };
  
};


- (void)drawArrows:(NSDictionary *)TheObj StartPt:(NSPoint)StartPt StartAngle:(double)StartAngle
                                            EndPt:(NSPoint)EndPt EndAngle:(double)EndAngle
{
  NSArray *Arrows = [TheObj objectForKey:OpenClip_Arrows];
  
  if (Arrows) {
    NSAffineTransform *t = [NSAffineTransform transform];
    [t translateXBy:StartPt.x
                yBy:StartPt.y];
    [t rotateByDegrees:StartAngle];
    [t concat];
    [self drawTheList:Arrows];
    [t invert];
    [t concat];
    
    
    NSAffineTransform *t2 = [NSAffineTransform transform];
    [t2 translateXBy:EndPt.x
                 yBy:EndPt.y];
    [t2 rotateByDegrees:EndAngle];
    [t2 concat];
    [self drawTheList:Arrows];
    [t2 invert];
    [t2 concat];
  }
  else {
    NSArray *StartArrows = [TheObj objectForKey:OpenClip_ArrowAtStart];
    
    if (StartArrows) {
      NSAffineTransform *t = [NSAffineTransform transform];
      [t translateXBy:StartPt.x
                  yBy:StartPt.y];
      [t rotateByDegrees:StartAngle];
      [t concat];
      [self drawTheList:StartArrows];
      [t invert];
      [t concat];
    }
    else {
      NSArray *EndArrows = [TheObj objectForKey:OpenClip_ArrowAtEnd];
      
      if (EndArrows) {
        NSAffineTransform *t2 = [NSAffineTransform transform];
        [t2 translateXBy:EndPt.x
                     yBy:EndPt.y];
        [t2 rotateByDegrees:EndAngle];
        [t2 concat];
        [self drawTheList:EndArrows];
        [t2 invert];
        [t2 concat];
      };
    
    };
  
  };

};


- (void)drawLine:(NSDictionary *)TheObj
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    NSPoint A;
    NSPoint B;
    
    //if (([self get2DPoint_:Points theIndex:0 thePt:&A]) && ([self get2DPoint_:Points theIndex:1 thePt:&B])) {
    if ((Get2DPointOpenClip(Points,0,&A)) && (Get2DPointOpenClip(Points,1,&B))) {
      NSBezierPath* ThePath = [NSBezierPath bezierPath];
      [ThePath setLineCapStyle:NSRoundLineCapStyle];
      [ThePath moveToPoint:A];
      [ThePath lineToPoint:B];
      
      //if ([self getPenColor_:TheObj]) {
      if (GetPenColorAndSetStrokeOpenClip(TheObj)) {
        
      };
      
      float PenSize = 1;
      //[self getPenSize_:TheObj TheSize:&PenSize];
      GetPenSizeOpenClip(TheObj,&PenSize);
      //[self getLineDash_:TheObj ThePath:ThePath];
      GetLineDashAndSetPathDash(TheObj,ThePath);
      
      [ThePath setLineWidth:PenSize];
      [ThePath stroke];
      
      double EndAngle = GetAngle(A,B);
      double StartAngle = GetAngle(B,A);
      
      [self drawArrows:TheObj StartPt:A StartAngle:StartAngle EndPt:B EndAngle:EndAngle];
    };
  
  };
  
};


- (void)drawRectangle:(NSDictionary *)TheObj
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    NSPoint A;
    NSPoint B;
    
    //if (([self get2DPoint_:Points theIndex:0 thePt:&A]) && ([self get2DPoint_:Points theIndex:1 thePt:&B])) {
    if ((Get2DPointOpenClip(Points,0,&A)) && (Get2DPointOpenClip(Points,1,&B))) {
      double Width  = fabs(A.x - B.x);
      double Height = fabs(A.y - B.y);
      double HalfWidth = Width / 2.0;
      double HalfHeight = Height / 2.0;
      
      NSPoint Ctr = NSMakePoint((A.x + B.x) / 2.0,(A.y + B.y) / 2.0);
            
      NSAffineTransform *t = [NSAffineTransform transform];
      [t translateXBy:Ctr.x
                  yBy:Ctr.y];
      
      NSRect TheRect = NSMakeRect(-HalfWidth,-HalfHeight,Width,Height);
      
      double TheRadius = 0.0;
      
      //if ([self getCornerRadius_:TheObj TheRadius:&TheRadius]) {
      if (GetCornerRadiusOpenClip(TheObj,&TheRadius)) {
      };
      
      NSBezierPath *ThePath = [NSBezierPath bezierPath];
      
      if (TheRadius == 0.0)
        [ThePath appendBezierPathWithRect:TheRect];
      else
        [ThePath appendBezierPathWithRoundedRect:TheRect xRadius:TheRadius yRadius:TheRadius]; // will not compile with 10.4
      
      double RotationAngle = 0;
      //if ([self getRotationAngle_:TheObj TheAngle:&RotationAngle])
      if (GetRotationAngleOpenClip(TheObj,&RotationAngle))
        [t rotateByDegrees:RotationAngle];
      
      [ThePath transformUsingAffineTransform:t];
      
      //if ([self getFillColor_:TheObj]) {
      if (GetFillColorAndSetFillOpenClip(TheObj)) {
        [ThePath fill];
      };
      
      //if ([self getPenColor_:TheObj]) {
      if (GetPenColorAndSetStrokeOpenClip(TheObj)) {
        
      };
      
      float PenSize = 1;
      //[self getPenSize_:TheObj TheSize:&PenSize];
      GetPenSizeOpenClip(TheObj,&PenSize);
      //[self getLineDash_:TheObj ThePath:ThePath];
      GetLineDashAndSetPathDash(TheObj,ThePath);
      [ThePath setLineWidth:PenSize];
      
      [ThePath stroke];
    };
    
  };

};


- (void)drawEllipse:(NSDictionary *)TheObj
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    NSPoint A;
    NSPoint B;
    
    //if (([self get2DPoint_:Points theIndex:0 thePt:&A]) && ([self get2DPoint_:Points theIndex:1 thePt:&B])) {
    if ((Get2DPointOpenClip(Points,0,&A)) && (Get2DPointOpenClip(Points,1,&B))) {
      double Width  = fabs(A.x - B.x);
      double Height = fabs(A.y - B.y);
      double HalfWidth = Width / 2.0;
      
      NSPoint Ctr = NSMakePoint((A.x + B.x) / 2.0,(A.y + B.y) / 2.0);
      
      NSAffineTransform *t = [NSAffineTransform transform];
      [t translateXBy:Ctr.x
                  yBy:Ctr.y];
                        
      NSRect TheRect = NSMakeRect(-HalfWidth,-HalfWidth,Width,Width);
      
      NSPoint StartPt;
      NSPoint EndPt;
      NSPoint BackStartPt;
      NSPoint BackEndPt;
      double StartAngle;
      double ArcAngle;
      double EndAngle;
      BOOL IsArc = NO;
      BOOL IsClockwise;
      
      //if ([self getStartAngle_:TheObj TheAngle:&StartAngle] && [self getArcAngle_:TheObj TheAngle:&ArcAngle]) {
      if (GetStartAngleOpenClip(TheObj,&StartAngle) && GetArcAngleOpenClip(TheObj,&ArcAngle)) {
        IsArc = YES;
        EndAngle = StartAngle + ArcAngle;
        IsClockwise = (ArcAngle < 0.0);
        StartPt = RadialNSPoint(NSZeroPoint,StartAngle,HalfWidth);
        EndPt = RadialNSPoint(NSZeroPoint,EndAngle,HalfWidth);
        
        if (IsClockwise) {
          BackStartPt = RadialNSPoint(NSZeroPoint,StartAngle - 5,HalfWidth);
          BackEndPt = RadialNSPoint(NSZeroPoint,EndAngle + 5,HalfWidth);
        }
        else {
          BackStartPt = RadialNSPoint(NSZeroPoint,StartAngle + 5,HalfWidth);
          BackEndPt = RadialNSPoint(NSZeroPoint,EndAngle - 5,HalfWidth);
        };
      };
        
      double RotationAngle = 0;
      //if ([self getRotationAngle_:TheObj TheAngle:&RotationAngle])
      if (GetRotationAngleOpenClip(TheObj,&RotationAngle))
        [t rotateByDegrees:RotationAngle];
        
      if (Width != Height)
        [t scaleXBy:1.0 yBy:(Height / Width)];
      
      NSBezierPath *ThePath = [NSBezierPath bezierPath];
      NSBezierPath *FillPath = [NSBezierPath bezierPath];
      
      if (IsArc) {
        [ThePath appendBezierPathWithArcWithCenter:NSZeroPoint
                                            radius:HalfWidth
                                        startAngle:StartAngle
                                          endAngle:EndAngle
                                         clockwise:IsClockwise];
        
        [FillPath moveToPoint:NSZeroPoint];
        [FillPath lineToPoint:StartPt];
        [FillPath appendBezierPathWithArcWithCenter:NSZeroPoint
                                            radius:HalfWidth
                                        startAngle:StartAngle
                                          endAngle:EndAngle
                                         clockwise:IsClockwise];
        [FillPath lineToPoint:NSZeroPoint];
      }
      else {
        [ThePath appendBezierPathWithOvalInRect:TheRect];
        [FillPath appendBezierPathWithOvalInRect:TheRect];
      };
      
      [ThePath transformUsingAffineTransform:t];
      
      //if ([self getFillColor_:TheObj]) {
      if (GetFillColorAndSetFillOpenClip(TheObj)) {
        [FillPath transformUsingAffineTransform:t];
        [FillPath fill];
      };
      
      //if ([self getPenColor_:TheObj]) {
      if (GetPenColorAndSetStrokeOpenClip(TheObj)) {
        
      };
      
      float PenSize = 1;
      //[self getPenSize_:TheObj TheSize:&PenSize];
      GetPenSizeOpenClip(TheObj,&PenSize);
      //[self getLineDash_:TheObj ThePath:ThePath];
      GetLineDashAndSetPathDash(TheObj,ThePath);
      [ThePath setLineWidth:PenSize];
      
      [ThePath stroke];

      if (IsArc) {
        StartPt = [t transformPoint:StartPt];
        EndPt = [t transformPoint:EndPt];
        BackStartPt = [t transformPoint:BackStartPt];
        BackEndPt = [t transformPoint:BackEndPt];
                
        double ArrowStartAngle = GetAngle(BackStartPt,StartPt);
        double ArrowEndAngle = GetAngle(BackEndPt,EndPt);
        
        [self drawArrows:TheObj StartPt:StartPt StartAngle:ArrowStartAngle EndPt:EndPt EndAngle:ArrowEndAngle];
      };
      
    };
    
  };  

};


- (void)drawPolygon:(NSDictionary *)TheObj
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    NSBezierPath* ThePath = [NSBezierPath bezierPath];
    [ThePath setLineCapStyle:NSRoundLineCapStyle];
    
    NSPoint StartPt;
    NSPoint EndPt;
    double StartAngle;
    double EndAngle;
    
    int LastN = [Points count] - 1;

    for (int N = 0; (N <= LastN); N++) {
      NSPoint A;
      NSPoint LastPt;
      
      //if ([self get2DPoint_:Points theIndex:N thePt:&A]) {
      if (Get2DPointOpenClip(Points,N,&A)) {
        
        if (N == 0) {
          [ThePath moveToPoint:A];
          LastPt = A;
          StartPt = A;
        }
        else {
          [ThePath lineToPoint:A];
          
          if (N == 1)
            StartAngle = GetAngle(A,LastPt);
          
          if (N == LastN) {
            EndAngle = GetAngle(LastPt,A);
            EndPt = A;
          };
          
          LastPt = A;
        };
      
      };
    
    };
    
    BOOL Closed = NO;
    //if ([self getObjectClosed_:TheObj Closed:&Closed]) {
    if (GetObjectClosedOpenClip(TheObj,&Closed)) {
      
      if (Closed)
        [ThePath closePath];
        
    };
    
    //if ([self getFillColor_:TheObj]) {
    if (GetFillColorAndSetFillOpenClip(TheObj)) {
      [ThePath fill];
    };
      
    //if ([self getPenColor_:TheObj]) {
    if (GetPenColorAndSetStrokeOpenClip(TheObj)) {
        
    };
    
    float PenSize = 1;
    //[self getPenSize_:TheObj TheSize:&PenSize];
    GetPenSizeOpenClip(TheObj,&PenSize);
    //[self getLineDash_:TheObj ThePath:ThePath];
    GetLineDashAndSetPathDash(TheObj,ThePath);
    [ThePath setLineWidth:PenSize];
    
    [ThePath stroke];
    
    if (! Closed)
      [self drawArrows:TheObj StartPt:StartPt StartAngle:StartAngle EndPt:EndPt EndAngle:EndAngle];
  };

};


- (void)drawBezier:(NSDictionary *)TheObj
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    NSBezierPath* ThePath = [NSBezierPath bezierPath];
    [ThePath setLineCapStyle:NSRoundLineCapStyle];
    int Step = 1;
    NSPoint B;
    NSPoint C;
    NSPoint D;
    
    NSPoint StartPt;
    NSPoint EndPt;
    double StartAngle;
    double EndAngle;
    
    int LastN = [Points count] - 1;
    
    for (int N = 0; (N <= LastN); N++) {
      NSPoint ThePt;
      //if ([self get2DPoint_:Points theIndex:N thePt:&ThePt]) {
      if (Get2DPointOpenClip(Points,N,&ThePt)) {
        
        if (N == 0) {
          [ThePath moveToPoint:ThePt];
          StartPt = ThePt;
        }
        else {
          
          if (N == 1)
            StartAngle = GetAngle(ThePt,StartPt);
            
          switch (Step) {
            case 1 : B = ThePt;
                     Step = 2;
                     break;
            case 2 : C = ThePt;
                     Step = 3;
                     break;
            case 3 : D = ThePt;
                     [ThePath curveToPoint:D
                              controlPoint1:B
                              controlPoint2:C];
                     Step = 1;
                     
                     if (N == LastN) {
                       EndPt = D;
                       EndAngle = GetAngle(C,D);
                     };
                     break;
          };
          
        };
      };
    };
    
    BOOL Closed = NO;
    //if ([self getObjectClosed_:TheObj Closed:&Closed]) {
    if (GetObjectClosedOpenClip(TheObj,&Closed)) {
      
      if (Closed)
        [ThePath closePath];
        
    };
    
    //if ([self getFillColor_:TheObj]) {
    if (GetFillColorAndSetFillOpenClip(TheObj)) {
      [ThePath fill];
    };
    
    //if ([self getPenColor_:TheObj]) {
    if (GetPenColorAndSetStrokeOpenClip(TheObj)) {
        
    };
    
    float PenSize = 1;
    //[self getPenSize_:TheObj TheSize:&PenSize];
    GetPenSizeOpenClip(TheObj,&PenSize);
    //[self getLineDash_:TheObj ThePath:ThePath];
    GetLineDashAndSetPathDash(TheObj,ThePath);
    [ThePath setLineWidth:PenSize];
    
    [ThePath stroke];
    
    if (! Closed)
      [self drawArrows:TheObj StartPt:StartPt StartAngle:StartAngle EndPt:EndPt EndAngle:EndAngle];
  };
  
};


- (void)drawTheList:(NSArray *)TheNSList
{
  NSEnumerator *e = [TheNSList objectEnumerator];
  
  NSDictionary *TheObj;
  while (TheObj = [e nextObject]) {
    
    NSString *nType = [TheObj objectForKey:OpenClip_ObjectType];
    
    if (nType) {
      
      if ([nType isEqualToString:OpenClip_PointObj]) {
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
  
        if (TheAdvancedList) {
          [self drawTheAdvancedList:TheAdvancedList];  // draw both here
        };
        
        [self drawPoint:TheObj];
      }
      else if ([nType isEqualToString:OpenClip_LineObj]) {
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
  
        if (TheAdvancedList) {
          [self drawTheAdvancedList:TheAdvancedList];  // draw both here
        };
        
        [self drawLine:TheObj];
      }
      else if ([nType isEqualToString:OpenClip_RectObj]) {
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
  
        if (TheAdvancedList) {
          [self drawTheAdvancedList:TheAdvancedList];  // draw both here
        };
        
        [self drawRectangle:TheObj];
      }
      else if ([nType isEqualToString:OpenClip_EllipseObj]) {
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
  
        if (TheAdvancedList) {
          [self drawTheAdvancedList:TheAdvancedList];  // draw both here
        };
        
        [self drawEllipse:TheObj];
      }
      else if ([nType isEqualToString:OpenClip_PolygonObj]) {
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
  
        if (TheAdvancedList) {
          [self drawTheAdvancedList:TheAdvancedList];  // draw both here
        };
        
        [self drawPolygon:TheObj];
      }
      else if ([nType isEqualToString:OpenClip_BezierObj]) {
        
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
  
        if (TheAdvancedList) {
          [self drawTheAdvancedList:TheAdvancedList];  // draw both here
        };
        
        [self drawBezier:TheObj];
      }
      else if ([nType isEqualToString:OpenClip_GroupObj]) {
        
        NSArray *TheGroupList = [TheObj objectForKey:OpenClip_DrawingObjects];
  
        if (TheGroupList)
          [self drawTheList:TheGroupList];
      
      };
    
    };

  };

};


- (void)drawTheAdvancedList:(NSArray *)TheNSList
{
  NSEnumerator *e = [TheNSList objectEnumerator];
  
  NSDictionary *TheObj;
  while (TheObj = [e nextObject]) {
    
    NSString *nType = [TheObj objectForKey:OpenClip_ObjectType];
    
    if (nType) {
      
      if ([nType isEqualToString:OpenClip_BSplineObj])
        [self drawPolygon:TheObj];
    
    };

  };

};


- (void)drawTheLayers:(NSArray *)TheNSLayerList
{
  NSEnumerator *e = [TheNSLayerList objectEnumerator];
  
  NSDictionary *TheNSLayer;
  while (TheNSLayer = [e nextObject]) {
    
    NSString *TheLayerName;
    //if ([self getLayerName:TheNSLayer theLayerName:TheLayerName]) {
    if (GetLayerNameOpenClip(TheNSLayer,TheLayerName)) {
      
    };
    
    float r,g,b,a;
    //if ([self getLayerColor:TheNSLayer r:&r g:&g b:&b a:&a]) {
    if (GetLayerColorOpenClip(TheNSLayer,&r,&g,&b,&a)) {
    
    };
    
    double TheLayerScale;
    //if ([self getLayerScale:TheNSLayer theScale:&TheLayerScale]) {
    if (GetLayerScaleOpenClip(TheNSLayer,&TheLayerScale)) {
    
    };
    
    // get layer drawing objects
    NSArray *TheNSList = [TheNSLayer objectForKey:OpenClip_DrawingObjects];
    
    if (TheNSList)
      [self drawTheList:TheNSList];
    
  };
  
};


- (void)drawOpenClipLogo
{
  NSImage *Logo = [NSImage imageNamed:@"logo"];

  if (Logo) {
    NSRect TheRect = [self bounds];
    
    NSSize ImageSize = [Logo size];
    double HalfWidth  = (ImageSize.width / 2.0);
    double HalfHeight = (ImageSize.height / 2.0);
    double LLX = NSMidX(TheRect) - HalfWidth;
    double LLY = NSMidY(TheRect) - HalfHeight;
    
    NSRect sourceRect = {{0.0,0.0},[Logo size]};
    NSRect destRect = NSMakeRect(LLX,LLY,ImageSize.width,ImageSize.height);
  
    [Logo drawInRect:destRect
            fromRect:sourceRect
           operation:NSCompositeSourceOver  // or NSCompositeCopy
            fraction:1.0];
             
  }
  else
    NSLog(@"couldn't load image");

};


- (void)writeToPasteboard:(NSDictionary*)TheDocument
{
  PasteboardRef theClipboard;

  OSStatus err = PasteboardCreate(kPasteboardClipboard,&theClipboard);
  PasteboardClear(theClipboard);
  
  //PasteboardSyncFlags syncFlags;
  //syncFlags = PasteboardSynchronize( theClipboard ); // 2
  
  NSData *TheData = [NSKeyedArchiver archivedDataWithRootObject:TheDocument];
  err = PasteboardPutItemFlavor(theClipboard,(PasteboardItemID)0,CFSTR("com.openclip.clip"),(CFDataRef)TheData,0);
};


- (BOOL)getOpenClip:(BOOL)doCopy
{
  BOOL Result = NO;
  
  NSFileManager *fileManager = [NSFileManager defaultManager];
  NSArray *Paths = NSSearchPathForDirectoriesInDomains(NSApplicationSupportDirectory,NSLocalDomainMask,NO);
  
  if ([Paths count] > 0) {  
    //NSString *OpenClipPath = @"/OpenClip";
    //NSLog([OpenClipPath lastPathComponent]);  // OpenClip
    
    //NSString *destinationPath = [[Paths objectAtIndex:0] stringByAppendingPathComponent:[OpenClipPath lastPathComponent]];
    NSString *destinationPath = [[Paths objectAtIndex:0] stringByAppendingPathComponent:@"OpenClip"];
    //NSLog(destinationPath); // /Library/Application Support/OpenClip
    
    if ([fileManager fileExistsAtPath:destinationPath]) {
      //NSLog(@"OpenClip Directory exists");
      
      //NSString *TheFilePath = [destinationPath stringByAppendingPathComponent:[OpenClipPath lastPathComponent]];
      //NSString *TheFilePath = [destinationPath stringByAppendingPathComponent:@"OpenClip"];
      NSString *TheFilePath = [destinationPath stringByAppendingPathComponent:mFileName];
      //NSLog(TheFilePath);  // /Library/Application Support/OpenClip/OpenClip
      
      NSFileHandle *theFileHandle = [NSFileHandle fileHandleForReadingAtPath:TheFilePath];
      
      NSDictionary *TheDocument = [NSDictionary dictionaryWithContentsOfFile:TheFilePath];
                      // [NSDictionary dictionaryWithContentsOfURL::ThePath];
      
      if (TheDocument) {
      
        double TheScale;
        //if ([self getScale:TheDocument theScale:&TheScale]) {
        if (GetScaleOpenClip(TheDocument,&TheScale)) {
        
        };
        
        NSPoint GlobalOrigin;
        //if ([self getGlobalOrigin:TheDocument theOrigin:&GlobalOrigin]) {
        if (GetGlobalOriginOpenClip(TheDocument,&GlobalOrigin)) {
        
        };
        
        NSPoint InsertionPoint;
        //if ([self getInsertionPoint:TheDocument thePt:&InsertionPoint]) {
        if (GetInsertionPointOpenClip(TheDocument,&InsertionPoint)) {
        
        };
        
        NSArray *TheNSLayerList = [TheDocument objectForKey:OpenClip_DrawingLayers];
        
        if (TheNSLayerList)
          [self drawTheLayers:TheNSLayerList];
        else {
          NSArray *TheNSList = [TheDocument objectForKey:OpenClip_DrawingObjects];
          
          if (TheNSList)
            [self drawTheList:TheNSList];
        
        };
        
        if (doCopy)
          [self writeToPasteboard:TheDocument];
        
        Result = YES;
      }
      
      [theFileHandle closeFile];  // this is all new stuff for me
  
    };
    
  };
  
  return Result;
};


- (void)drawRect:(NSRect)rect
{
  NSRect TheRect = [self bounds];
  NSEraseRect(TheRect);

  if (! [self getOpenClip:NO])
    [self drawOpenClipLogo];
  
  [[NSColor grayColor] set];
  NSFrameRect(TheRect);
}

@end
