//----------------------------------------------------------------------------------------------

// OpenClipController.h

//----------------------------------------------------------------------------------------------

// Copyright:	© 2014 by Sequoia Aircraft Corporation., all rights reserved.

#import <Cocoa/Cocoa.h>
#import "OpenClipView.h"

@interface OpenController : NSObject
{
  IBOutlet OpenClipView*    mView;
  
  IBOutlet NSPopUpButton*	  mBasicViewsBtn;
  IBOutlet NSPopUpButton*	  mExtraViewsBtn;
}

- (IBAction)copyToPasteboard:(id)sender;
- (IBAction)refresh:(id)sender;
- (IBAction)basicViews:(id)sender;
- (IBAction)extraViews:(id)sender;

- (IBAction)printThis:(id)sender;


@end