//----------------------------------------------------------------------------------------------

// OpenClipDoc.h

//----------------------------------------------------------------------------------------------



@interface OpenClipDoc : NSObject
{
  NSDictionary *mDocument;
}

- (id)init;
- (void)dealloc;

- (void)drawPoint:(NSDictionary *)TheObj;

- (void)drawArrows:(NSDictionary *)TheObj StartPt:(NSPoint)StartPt StartAngle:(double)StartAngle
                                            EndPt:(NSPoint)EndPt EndAngle:(double)EndAngle;
  
- (void)drawLine:(NSDictionary *)TheObj;
- (void)drawRectangle:(NSDictionary *)TheObj;
- (void)drawEllipse:(NSDictionary *)TheObj;
- (void)drawPolygon:(NSDictionary *)TheObj;
- (void)drawBezier:(NSDictionary *)TheObj;

- (void)drawTheList:(NSArray *)TheNSList;
- (void)drawTheAdvancedList:(NSArray *)TheNSList;

- (void)drawTheLayers:(NSArray *)TheNSLayerList;

- (void)writeToPasteboard;

- (BOOL)openFile:(NSString*)theFileName;

- (void)draw;


@end